<?php

// Authentification

if (@file_exists('inc/auth.inc.php') && @include_once 'inc/auth.inc.php');
else exit;

// General options

$ezin_opts['dbh'] = ezin_open_db_connection();
$ezin_opts['tb']  = $ezin_sys['db']['tables']['sources'];
$ezin_opts['key'] = 'id';
$ezin_opts['key_type'] = 'int';
$ezin_opts['inc'] = -1;
$ezin_opts['options'] = $ezin_user['role_sections'];
$ezin_opts['multiple'] = '4';
$ezin_opts['navigation'] = $ezin_cfg['admin_navigation'].$ezin_cfg['admin_buttons_pos'];
$ezin_opts['display'] = array('query' => false, 'sort'  => false, 'time'  => false);
$ezin_opts['url'] = array('images' => 'icons/');
$ezin_opts['language'] = 'EN';

// Triggers
$ezin_opts['triggers']['insert']['after'][] = 'inc-db/triggers/sources.after';
$ezin_opts['triggers']['update']['after'][] = 'inc-db/triggers/sources.after';
$ezin_opts['triggers']['delete']['after'][] = 'inc-db/triggers/sources.after';

// Field definitions

$ezin_opts['fdd']['id'] = array(
		'name'=>'ID',
		'select'=>'T',
		'maxlen'=>3,
		'sort'=>true,
		'options'=>'LDVFPCR',
		'colattrs|LF' => 'align="center"',
		);

$ezin_opts['fdd']['source_type'] = array(
		'name'=>'Src',
		'select'=>'T',
		'required'=>true,
		'values' => array('rss'),
		'options'=>'ACPVDF'
		);

$ezin_opts['fdd']['section_id'] = array(
		'name'=>'Section',
		'select'=>'D',
		'sort'=>true,
		'required'=>true,
		'strip_tags'=>true,
		'values'=>array(
			'table' => $ezin_sys['db']['tables']['sections'],
			'orderby' => 'lang,ord,id',
			'column' => 'id',
			'description' => array(
				'columns' => array('name', 'id', 'lang'),
				'divs'    => array(' (', ') ',''))),
		);


$ezin_opts['fdd']['url'] = array(
		'name'=>'URL',
		'select'=>'T',
		'maxlen'=>255,
		'required'=>true
		);

$ezin_opts['fdd']['normal_refresh_time'] = array(
		'name|LF'=>'Refresh time',
		'name'=>'Normal refresh (minutes)',
		'select'=>'T',
		'required'=>true
		);
		
$ezin_opts['fdd']['fail_refresh_time'] = array(
		'name|LF'=>'Fail refresh',
		'name'=>'Fail refresh (minutes)',
		'select'=>'T',
		'required'=>true,
		'options'=>'ACPVDF'
		);
		
$ezin_opts['fdd']['connection_timeout'] = array(
		'name|LF'=>'Connection timeout',
		'name'=>'Connection timeout (seconds)',
		'select'=>'T',
		'required'=>true,
		'options'=>'ACPVDF'
		);


include dirname(__FILE__).'/_credentials.inc.php';

// Execution code

if (! ezin_admin_check_list_privileges($ezin_opts['options'])) {
	require 'inc-html/permdenied.html';
} else {
	require_once 'phpMyEdit/phpMyEdit.class.php';
	new phpMyEdit($ezin_opts);
}

?>
