--
-- Metafox - flexible content management system
--
-- sql/config/descriptions.sql - configuration descriptions
-- ____________________________________________________________
--
-- Developed by Ondrej Jombik <nepto@platon.sk>
-- Copyright (c) 2001-2008 Platon Group, http://platon.sk/
-- All rights reserved.
--
-- See README file for more information about this software.
-- See COPYING file for license information.
--
-- Download the latest version from
-- http://platon.sk/projects/Metafox/
--

--
-- TABLE CREATIONS
--

DROP TABLE IF EXISTS ezin_config_info;

CREATE TABLE ezin_config_info (
		a_key char(32) NOT NULL,
		ord int,
		name varchar(255),
		description text,
		primary key (a_key)
		);

INSERT INTO ezin_config_info (a_key) VALUES ('name');
INSERT INTO ezin_config_info (a_key) VALUES ('abbreviation');
INSERT INTO ezin_config_info (a_key) VALUES ('encoding');
INSERT INTO ezin_config_info (a_key) VALUES ('admin_email');
INSERT INTO ezin_config_info (a_key) VALUES ('url');
INSERT INTO ezin_config_info (a_key) VALUES ('theme');
INSERT INTO ezin_config_info (a_key) VALUES ('color_highlight');
-- Removed 11/1/2003
-- INSERT INTO ezin_config_info (a_key) VALUES ('line_wrap_p');
-- INSERT INTO ezin_config_info (a_key) VALUES ('line_wrap_br');
INSERT INTO ezin_config_info (a_key) VALUES ('format_date');
INSERT INTO ezin_config_info (a_key) VALUES ('format_datetime');
INSERT INTO ezin_config_info (a_key) VALUES ('order_articles_desc');
INSERT INTO ezin_config_info (a_key) VALUES ('order_messages_desc');
INSERT INTO ezin_config_info (a_key) VALUES ('admin_session_timeout');
INSERT INTO ezin_config_info (a_key) VALUES ('session_timeout');
-- INSERT INTO ezin_config_info (a_key) VALUES ('session_cookie_name');
INSERT INTO ezin_config_info (a_key) VALUES ('admin_buttons_pos');
INSERT INTO ezin_config_info (a_key) VALUES ('message_flood_timeout');
-- Added 8/9/2002
INSERT INTO ezin_config_info (a_key) VALUES ('message_max_word_size');
INSERT INTO ezin_config_info (a_key) VALUES ('message_allowed_tags');
-- Added 17/8/2002
INSERT INTO ezin_config_info (a_key) VALUES ('redirect_index');
INSERT INTO ezin_config_info (a_key) VALUES ('redirect_others');
INSERT INTO ezin_config_info (a_key) VALUES ('link_file_type');
-- Added 24/10/2002
INSERT INTO ezin_config_info (a_key) VALUES ('admin_navigation');
-- Added 26/10/2002
INSERT INTO ezin_config_info (a_key) VALUES ('languages');
-- Added 11/1/2003
INSERT INTO ezin_config_info (a_key) VALUES ('flags_article_hometext');
INSERT INTO ezin_config_info (a_key) VALUES ('flags_article_bodytext');
INSERT INTO ezin_config_info (a_key) VALUES ('flags_editorial');
INSERT INTO ezin_config_info (a_key) VALUES ('flags_message');
INSERT INTO ezin_config_info (a_key) VALUES ('message_save_redirect');
INSERT INTO ezin_config_info (a_key) VALUES ('debug_level');
-- Added 22/1/2003
INSERT INTO ezin_config_info (a_key) VALUES ('feedback_email');
INSERT INTO ezin_config_info (a_key) VALUES ('feedback_save_redirect');
-- Added 17/4/2003
INSERT INTO ezin_config_info (a_key) VALUES ('http_host_redirect');
-- INSERT INTO ezin_config_info (a_key) VALUES ('http_host_exclude');
-- Added 27/7/2003
INSERT INTO ezin_config_info (a_key) VALUES ('admin_auth_function');
INSERT INTO ezin_config_info (a_key) VALUES ('admin_auth_login_redirect');
INSERT INTO ezin_config_info (a_key) VALUES ('admin_auth_logout_redirect');
-- Added 14/12/2004
INSERT INTO ezin_config_info (a_key) VALUES ('http_host_allowed');
INSERT INTO ezin_config_info (a_key) VALUES ('http_host_forbidden');
-- Added 18/12/2004
INSERT INTO ezin_config_info (a_key) VALUES ('mail_method');
INSERT INTO ezin_config_info (a_key) VALUES ('mail_sendmail_path');
INSERT INTO ezin_config_info (a_key) VALUES ('mail_smtp_host_port');
-- Added 2006-02-01
INSERT INTO ezin_config_info (a_key) VALUES ('flags_author');
-- Added 2006-09-15
INSERT INTO ezin_config_info (a_key) VALUES ('antispam_flags');
INSERT INTO ezin_config_info (a_key) VALUES ('antispam_question');
INSERT INTO ezin_config_info (a_key) VALUES ('antispam_answer');
-- Added 2006-09-20
INSERT INTO ezin_config_info (a_key) VALUES ('description');
-- Added 2007-02-24
INSERT INTO ezin_config_info (a_key) VALUES ('user_create_email');
INSERT INTO ezin_config_info (a_key) VALUES ('user_create_role_id');
-- Added 2010-09-30
INSERT INTO ezin_config_info (a_key) VALUES ('gallery_type');
-- Added 2010-10-15
INSERT INTO ezin_config_info (a_key) VALUES ('calendar');
-- Added 2010-11-02
INSERT INTO ezin_config_info (a_key) VALUES ('featured_articles');
INSERT INTO ezin_config_info (a_key) VALUES ('featured_articles_limit');
-- Added 2010-12-10
INSERT INTO ezin_config_info (a_key) VALUES ('calendar_popup_display');
-- Added 2011-06-09
INSERT INTO ezin_config_info (a_key) VALUES ('soap_server_enabled');
-- Added 2012-10-01
INSERT INTO ezin_config_info (a_key) VALUES ('antispam_type');
-- Added 2012-10-07
INSERT INTO ezin_config_info (a_key) VALUES ('antispam_type');
-- Added 2013-09-03
INSERT INTO ezin_config_info (a_key) VALUES ('http_host_language');
-- Added 2013-10-17
INSERT INTO ezin_config_info (a_key) VALUES ('platon_newsletter_enabled');
INSERT INTO ezin_config_info (a_key) VALUES ('platon_newsletter_password');

--
-- DESCRIPTIONS
--

UPDATE ezin_config_info SET
ord = 110,
name = 'E-zin name',
description =
'Your e-zin name. Just type here text, how does you e-zin called. This variable
has no special meaning. It will be used in templates for proper e-zin name
displaying.'
WHERE a_key = 'name';

UPDATE ezin_config_info SET
ord = 115,
name = 'E-zin description',
description =
'Your e-zin description. Put here one or two sentences or slogan of your
company or organization.'
WHERE a_key = 'description';

UPDATE ezin_config_info SET
ord = 120,
name = 'E-zin abbreviation',
description =
'Your e-zin abbreviation. It will be used in several cases, when unique string
will be needed for e-zin. Don\'t use whitechars, colons, semicolons or similar
characters. Also note, that changing this varaible in future may cause several
problems with Metafox functionality.'
WHERE a_key = 'abbreviation';

UPDATE ezin_config_info SET
ord = 130,
name = 'E-zin encoding',
description =
'Your e-zin encoding charset. It will be mainly used in templates for proper
META tag creation. It can be also used for string conversions in future.
Examples of valid encodings are iso-8859-1, iso-8859-2, windows-1250 and so
on.'
WHERE a_key = 'encoding';

UPDATE ezin_config_info SET
ord = 140,
name = 'E-zin languages',
description =
'Possible e-zin languages. Use two letters language codes such as "sk" for
Slovak language or "en" for english language. Separate codes with space and
note, that first language in the list is considered as default.'
WHERE a_key = 'languages';

UPDATE ezin_config_info SET
ord = 150,
name = 'E-zin URL',
description =
'Your e-zin URL (uniform resource locator). You don\'t need to type also
hostname with protocol here. This variable will be mainly used for creating
link and references prefix.'
WHERE a_key = 'url';

UPDATE ezin_config_info SET
ord = 153,
name = 'Language by HTTP hosts',
description =
'This option defines HTTP hosts, whereby will be set language. For each language
separate in brackets HTTP host names with space character and write them in
lower case. Identificator of language write before each brackets.'
WHERE a_key = 'http_host_language';

UPDATE ezin_config_info SET
ord = 155,
name = 'Redirect HTTP host',
description =
'This option specifies mandatory HTTP host used for serving pages. You website
can act on several HTTP hosts. Here you have an opportunity to specify which
one from the set is mandatory. If request is performed on other HTTP host,
redirect location header will be answered. You can use also path part of URL
for redirect.'
WHERE a_key = 'http_host_redirect';

UPDATE ezin_config_info SET
ord = 156,
name = 'Allowed HTTP hosts',
description =
'This is a possibility to define HTTP hosts, which are excluded from action
defined by previous Redirect HTTP host option. Separate HTTP host names with
space character and write them in lower case.'
WHERE a_key = 'http_host_allowed';

UPDATE ezin_config_info SET
ord = 157,
name = 'Forbidden HTTP hosts',
description =
'This option defines HTTP hosts which are forbidden and must be redirected to
Redirect HTTP host. If option is blank of missing, than every host is
considered as forbidden except those specified in Allowed HTTP hosts. Separate
HTTP host names with space character and write them in lower case.'
WHERE a_key = 'http_host_forbidden';

UPDATE ezin_config_info SET
ord = 160,
name = 'Highlight color',
description =
'Define here highlight color for your e-zin. It will be used for highlighting
of some elements in your e-zin, mainly in admin part. Any HTML compliant color
can be specified here.'
WHERE a_key = 'color_highlight';

UPDATE ezin_config_info SET
ord = 170,
name = 'Selected theme',
description =
'Selected theme of your e-zin. This issue in fact selects directory from
themes/ subdirectory, where are themes placed. Theme is set of templates,
images and cascade stylesheets.'
WHERE a_key = 'theme';

UPDATE ezin_config_info SET
ord = 175,
name = 'Type of gallery',
description =
'Selected type of gallery.'
WHERE a_key = 'gallery_type';

UPDATE ezin_config_info SET
ord = 176,
name = 'Calendar popup display',
description =
'Place where appears popup window from day cell'
WHERE a_key = 'calendar_popup_display';

UPDATE ezin_config_info SET
ord = 177,
name = 'Calendar',
description =
'This input option access the events calendar for Articles.'
WHERE a_key = 'calendar';

UPDATE ezin_config_info SET
ord = 178,
name = 'Featured articles',
description =
'Separate highlight featured articles.'
WHERE a_key = 'featured_articles';

UPDATE ezin_config_info SET
ord = 179,
name = 'Featured articles limit',
description =
'Set the limit to see featured articles.'
WHERE a_key = 'featured_articles_limit';

UPDATE ezin_config_info SET
ord = 180,
name = 'Debug level',
description =
'Debug level value.'
WHERE a_key = 'debug_level';

UPDATE ezin_config_info SET
ord = 190,
name = "Enabled SOAP server",
description =
"Access SOAP server"
WHERE a_key = "soap_server_enabled"

UPDATE ezin_config_info SET
ord = 195,
name = "Platon Newsletter Source",
description =
"Access Platon Newsletter source extension"
WHERE a_key = "platon_newsletter_enabled"

UPDATE ezin_config_info SET
ord = 196,
name = "Password for Platon Newsletter",
description =
"Password for Platon Newsletter source extension"
WHERE a_key = "platon_newsletter_password"

--
-- 200
--

UPDATE ezin_config_info SET
ord = 205,
name = 'E-mail prefered method',
description =
'The prefered method for sending e-mail messages. Choose the most suitable one
from the "mail()", "sendmail" and "smtp" set.'
WHERE a_key = 'mail_method';

UPDATE ezin_config_info SET
ord = 206,
name = 'E-mail sendmail path',
description =
'Path for sendmail binary. When missing or empty /usr/sbin/sendmail will be used.'
WHERE a_key = 'mail_sendmail_path';

UPDATE ezin_config_info SET
ord = 207,
name = 'E-mail SMTP host',
description =
'SMTP host and port in "host:port" form. When port part is missing, the default
SMTP port 25 will be used. When whole option is missing or empty, default
"localhost:25" will be used.'
WHERE a_key = 'mail_smtp_host_port';

UPDATE ezin_config_info SET
ord = 208,
name = 'New user role',
description =
'Role of new user.This role should be defined in roles table.
Select "no role" to forbid creation of new user account.'
WHERE a_key = 'user_create_role_id';

UPDATE ezin_config_info SET
ord = 209,
name = 'New user e-mail',
description =
'E-mail address where to sent information message when new user create an
account.  You can specify more than one e-mail address. Separate items with
space.'
WHERE a_key = 'user_create_email';

UPDATE ezin_config_info SET
ord = 210,
name = 'Administrator e-mail',
description =
'E-mail address of this e-zin administrator. This address will be used in
exmaple for sending particular error messages, when some error occurs. You can
specify more than one e-mail address. Separate items with space.'
WHERE a_key = 'admin_email';

UPDATE ezin_config_info SET
ord = 220,
name = 'Feedback e-mail',
description =
'E-mail address where to send feedback form posts. Feedback form posts are also
stored in database, e-mail messaging feature is fully optional. You can specify
more than one e-mail address. Separate items with space.'
WHERE a_key = 'feedback_email';

UPDATE ezin_config_info SET
ord = 230,
name = 'Feedback save redirect',
description =
'This option prevents agaings duplicate feedback submits by making redirect
just after feedback save. Thus further reloads are safe and will not cause any
duplicate feedback save.'
WHERE a_key = 'feedback_save_redirect';

UPDATE ezin_config_info SET
ord = 235,
name = 'Feedback flood timeout',
description =
'Set the amount of time in seconds used by flood check to prevent feedback post
flooding. Your specified time is minimum required time to wait for ability to
post next message from one IP address. Recommended value is 30. Enter the number
of seconds only. Set it to 0 to not have flood protection.'
WHERE a_key = 'feedback_flood_timeout';

UPDATE ezin_config_info SET
ord = 240,
name = 'Antispam protection',
description =
'Where should be antispam protection applied.'
WHERE a_key = 'antispam_flags';

UPDATE ezin_config_info SET
ord = 244,
name = 'Antispam type',
description =
'Selected type of antispam.'
WHERE a_key = 'antispam_type';

UPDATE ezin_config_info SET
ord = 245,
name = 'Antispam question',
description =
'To prevent nasty people before spamming your e-zin, you can optionally provide
some simple antispam question, which is answerable only by humans. Robots will
not be able to submit the feedback or discussion message.'
WHERE a_key = 'antispam_question';

UPDATE ezin_config_info SET
ord = 246,
name = 'Antispam answer',
description =
'To prevent nasty people before spamming your e-zin, you can optionally provide
some answer to simple antispam question, which is answerable only by humans.
User input will be compared with antispam answer. If they do not match,
feedback or discussion message will be ignored.'
WHERE a_key = 'antispam_answer';

UPDATE ezin_config_info SET
ord = 250,
name = 'Articles annotation flags',
description =
'This options specifies how to wrap article annotations. There are two
different approaches possible. They can be used both or none at the one time.
The first one will wrap line on every line break, the second will create new
paragraph when empty line occurs in text.<p>Second part deal with links substitution in
parsed text.'
WHERE a_key = 'flags_article_hometext';

UPDATE ezin_config_info SET
ord = 260,
name = 'Articles flags',
description =
'This options specifies how to wrap article texts. There are two
different approaches possible. They can be used both or none at the one time.
The first one will wrap line on every line break, the second will create new
paragraph when empty line occurs in text.<p>Second part deal with links substitution in
parsed text.'
WHERE a_key = 'flags_article_bodytext';

UPDATE ezin_config_info SET
ord = 270,
name = 'Editorials flags',
description =
'This options specifies how to wrap editorial texts. There are two different
approaches possible. They can be used both or none at the one time.  The first
one will wrap line on every line break, the second will create new paragraph
when empty line occurs in text.<p>Second part deal with links substitution in
parsed text.'
WHERE a_key = 'flags_editorial';

UPDATE ezin_config_info SET
ord = 280,
name = 'Messages flags',
description =
'This options specifies how to wrap message texts. There are two
different approaches possible. They can be used both or none at the one time.
The first one will wrap line on every line break, the second will create new
paragraph when empty line occurs in text.<p>Second part deal with links substitution in
parsed text.'
WHERE a_key = 'flags_message';

UPDATE ezin_config_info SET
ord = 290,
name = 'Author flags',
description =
'This options specifies how to wrap author description texts. There are two
different approaches possible. They can be used both or none at the one time.
The first one will wrap line on every line break, the second will create new
paragraph when empty line occurs in text.<p>Second part deal with links substitution in
parsed text.'
WHERE a_key = 'flags_author';

--
-- 300
--

UPDATE ezin_config_info SET
ord = 310,
name = 'Date format',
description =
'You e-zin specific date formatting. You can set any formatting, that fits your
needs. String of this option will be exactly passed to date() function of PHP
interpreter. You can find more info <a target=_blank
href="http://www.php.net/manual/en/function.date.php">here</a>.'
WHERE a_key = 'format_date';

UPDATE ezin_config_info SET
ord = 310,
name = 'Date & Time format',
description =
'You e-zin specific date and time formatting. You can set any formatting, that
fits your needs. String of this option will be exactly passed to date()
function of PHP interpreter. You can find more info <a target=_blank
href="http://www.php.net/manual/en/function.date.php">here</a>.'
WHERE a_key = 'format_datetime';

--
-- 400
--

UPDATE ezin_config_info SET
ord = 410,
name = 'Articles order',
description =
'Order of e-zin articles in section. It can be ascending or descending.'
WHERE a_key = 'order_articles_desc';

UPDATE ezin_config_info SET
ord = 411,
name = 'Messages order',
description =
'Order of e-zin messages in section. It can be ascending or descending.'
WHERE a_key = 'order_messages_desc';

--
-- 450
--

UPDATE ezin_config_info SET
ord = 450,
name = 'Messages flood timeout',
description =
'Set the amount of time in seconds used by flood check to prevent messages post
flooding. Your specified time is minimum required time to wait for ability to
post next message from one IP address. Recommended value is 30. Enter the number
of seconds only. Set it to 0 to not have flood protection.'
WHERE a_key = 'message_flood_timeout';

UPDATE ezin_config_info SET
ord = 450,
name = 'Messages maximum word length',
description =
'Option defines maximum length of word, which can be entered in messages by
website users. If any word will exceed specified size, one or more whitespaces
will inserted on the place of first invalid character.'
WHERE a_key = 'message_max_word_size';

UPDATE ezin_config_info SET
ord = 450,
name = 'Messages allowed tags',
description =
'You can specify here particular tags, which will be allowed in entering
messages. Separate tag names with spaces. Use color (:) to mark compulsory
attribute. Use semicolon to mark arbitrary attribute, which will be added
defined value. Other attributes will be removed.'
WHERE a_key = 'message_allowed_tags';

UPDATE ezin_config_info SET
ord = 460,
name = 'Messages save redirect',
description =
'Reloading after message submit is common problem which causes duplicate messages in
discussion forums. This option prevents agaings this issue by making redirect
just after message save. Thus further reloads are safe and will not cause any
duplicate message save.'
WHERE a_key = 'message_save_redirect';

--
-- 500
--

UPDATE ezin_config_info SET
ord = 510,
name = 'Link type',
description =
'You can choose from two types of links. The first one use only index.php file
and all elements (section, articles, etc.) are accessed via this file with
appropriate parameters passed. The second type of links use also additional
files such as section.php for accessing section, article.php for articles and
so on.'
WHERE a_key = 'link_file_type';

UPDATE ezin_config_info SET
ord = 515,
name = 'Link redirect',
description =
'Other types of links redirect to a selected type'
WHERE a_key = 'link_redirect';

UPDATE ezin_config_info SET
ord = 517,
name = 'Redirect equal URL',
description =
'Redirect equal type of URL.'
WHERE a_key = 'redirect_equal_type';

UPDATE ezin_config_info SET
ord = 520,
name = '404 index.php redirect',
description =
'This option defines where to redirect (using internal Metafox redirect or
classical HTTP/1.1 redirect) when index.php file is accessed, but no ezin
parameters are present in CGI interface. This situation commonly happened when
ezin is accessed for the first time of user session. You can specify here for
example the index of you main global section.'
WHERE a_key = 'redirect_index';

UPDATE ezin_config_info SET
ord = 530,
name = '404 other files redirect',
description =
'This option defines where to redirect (using internal Metafox redirect or
classical HTTP/1.1 redirect) when other file than index.php file is accessed,
but no ezin parameters are present in CGI interface. This situation commonly
happened when someone link you ezin with invalid link. You can specify here for
example some hidden article with some help information how to access
destination article.'
WHERE a_key = 'redirect_others';

--
-- 600
--

UPDATE ezin_config_info SET
ord = 610,
name = 'Session timeout',
description = 
'Session timeout defines maximum possible time of inactivity. After that
session expires. It is used for website visitors, where after session timeout
is user counted as new. It is used in example for counting number of article
readers.'
WHERE a_key = 'session_timeout';

UPDATE ezin_config_info SET
ord = 620,
name = 'Admin session timeout',
description = 
'Admin session timeout similary defines maximum possible time of inactivity,
but in this case in admin part of e-zin. After session timeout administrator
will automatically logged out. Define value of 0 to set unlimited session
timeout. This could be used in debug mode, when logging out from admin part is
not desirable. But we strongly not recommend you this setting on production
sites.'
WHERE a_key = 'admin_session_timeout';

-- UPDATE ezin_config_info SET
-- ord = 630,
-- name = 'Session cookie name',
-- description =
-- 'Name of cookie used for storing session informations, such as session ID.
-- Session ID is number used for used autorization in Metafox admin part.'
-- WHERE a_key = 'session_cookie_name';

UPDATE ezin_config_info SET
ord = 640,
name = 'Admin authentification function',
description = 
'This option defines a name of function, which will return a name of user,
which was already authentificated on the client\'s part of Metafox system. If
such username does not exist in Metafox user table, user won\'t be logged in.
If username exists in the mentioned table, user will be logged in with
permissions accordint to its role based on Metafox role table.'
WHERE a_key = 'admin_auth_function';

UPDATE ezin_config_info SET
ord = 650,
name = 'Admin auth login redirect',
description = 
'Option apply only if "Admin authentification function" is defined and working
correctly. Admin authentification login redirect defines URL where user should
be redirected, if user entered Metafox administration part, but he or she is
not yet authentificated. Full URL is allowed. URL starting with slash will be
considered for current HTTP host and URL without schema/protocol or slash at
the begining will be considered as current HTTP host with e-zin URL appended.'
WHERE a_key = 'admin_auth_login_redirect';

UPDATE ezin_config_info SET
ord = 660,
name = 'Admin auth logout redirect',
description = 
'Option apply only if "Admin authentification function" is defined and working
correctly. Admin authentification login redirect defines URL where user should
be redirected, if user click on the logout link in the Metafox administration
part.  Full URL is allowed. URL starting with slash will be considered for
current HTTP host and URL without schema/protocol or slash at the begining will
be considered as current HTTP host with e-zin URL appended.'
WHERE a_key = 'admin_auth_logout_redirect';

--
-- 700
--

UPDATE ezin_config_info SET
ord = 710,
name = 'Admin navigation',
description =
'It is possible to choose from several types of navigation in administration
part of Metafox system. Navigation styles can be freely combined to get
desirable behaviour.'
WHERE a_key = 'admin_navigation';

UPDATE ezin_config_info SET
ord = 720,
name = 'Admin buttons position',
description =
'Possition of navigation buttons in Metafox administration part. We recommend
you to use `up\' position of buttons, because it is easier to navigate.'
WHERE a_key = 'admin_buttons_pos';

UPDATE ezin_config_info SET
ord = 730,
name = 'HTTPS redirect for ADMIN',
description =
'We recommend you to use autotedect. For security of communication with admin
interface to use HTTPS.'
WHERE a_key = 'https_admin';
