delete from ezin_cache;
alter table ezin_cache modify id varchar(64);

--
-- ANTISPAM
--
delete from ezin_messages where author = 'online casino';
delete from ezin_messages where subject = 'texas holdem';
delete from ezin_messages where author like '%a href%http://%';

-- FEEDBACK DATA INTEGRITY
delete from ezin_feedback_data where feedback_id not in (select id from ezin_feedbacks);

-- mysql> select author, count(*) from ezin_messages where id > 24605 and article_id = 455 group by author;
-- +--------------------------+----------+
-- | author                   | count(*) |
-- +--------------------------+----------+
-- | 7 card stud              |      651 |
-- | 7 card stud online       |      322 |
-- | 7 card stud poker        |      116 |
-- | 888                      |      866 |
-- | 888 casino               |      262 |
-- | 888 pacific poker        |      413 |
-- | baccarat                 |      380 |
-- | baccarat online          |      254 |
-- | backgammon               |      169 |
-- | bingo                    |      462 |
-- | blackjack                |      227 |
-- | craps                    |      714 |
-- | empire poker             |      304 |
-- | empire poker bonus       |      302 |
-- | empire poker bonus code  |      568 |
-- | free 7 card stud         |      529 |
-- | free baccarat            |      224 |
-- | free backgammon          |      545 |
-- | free bingo               |      170 |
-- | free blackjack           |      309 |
-- | free casino game         |      334 |
-- | free craps               |      294 |
-- | free keno                |      854 |
-- | free omaha poker         |      430 |
-- | free online poker        |      720 |
-- | free roulette            |      421 |
-- | free seven card stud     |      715 |
-- | free slots               |      577 |
-- | free texas hold em       |      534 |
-- | free texas holdem        |      705 |
-- | free video poker         |      284 |
-- | keno                     |      381 |
-- | omaha hi lo              |      442 |
-- | omaha hi lo poker        |      819 |
-- | omaha poker online       |      409 |
-- | online backgammon        |      452 |
-- | online bingo             |      245 |
-- | online blackjack         |      746 |
-- | online casino game       |      201 |
-- | online casino review     |      327 |
-- | online craps             |      376 |
-- | online keno              |      524 |
-- | online poker             |      552 |
-- | online poker game        |      158 |
-- | online poker rooms       |      272 |
-- | online poker tournament  |      807 |
-- | online roulette          |      292 |
-- | online seven card stud   |      613 |
-- | online slots             |      820 |
-- | online texas hold em     |      457 |
-- | online texas holdem      |      507 |
-- | online video poker       |      341 |
-- | pacific poker            |      636 |
-- | pacific poker bonus      |      602 |
-- | pacific poker bonus code |      139 |
-- | party poker              |      668 |
-- | party poker bonus        |      395 |
-- | party poker bonus code   |      178 |
-- | party poker com          |      715 |
-- | play baccarat online     |      299 |
-- | play backgammon online   |      262 |
-- | play bingo online        |      382 |
-- | play blackjack online    |      596 |
-- | play craps online        |       96 |
-- | play keno online         |      240 |
-- | play online slots        |      627 |
-- | play poker online        |      296 |
-- | play roulette online     |      169 |
-- | play video poker online  |      492 |
-- | roulette                 |      264 |
-- | seven card stud          |      135 |
-- | seven card stud poker    |      445 |
-- | slots                    |      359 |
-- | texas hold em            |      504 |
-- | texas hold em poker      |      573 |
-- | texas holdem poker       |      218 |
-- | video poker              |      329 |
-- +--------------------------+----------+
-- 77 rows in set (1.62 sec)
-- 
-- mysql>

-- mysql> select a.id, a.message_count, count(*) cnt from ezin_articles a, ezin_messages m
-- where a.id = m.article_id group by a.id having a.message_count != cnt;
-- +-----+---------------+------+
-- | id  | message_count | cnt  |
-- +-----+---------------+------+
-- |  65 |           134 |  131 |
-- | 140 |            23 |   24 |
-- | 211 |            39 |   31 |
-- | 217 |            15 |   16 |
-- | 228 |           596 |  594 |
-- | 251 |           135 |  136 |
-- | 269 |            23 |   22 |
-- | 400 |           371 |  365 |
-- | 424 |           873 |  872 |
-- | 450 |          3181 | 3040 |
-- | 455 |         34171 |  509 |
-- +-----+---------------+------+
-- 11 rows in set (0.18 sec)
-- 
-- mysql>

alter table ezin_articles modify bodytext longtext;
update ezin_sections set lang = '' where lang is null;

alter table ezin_authors add type enum('internal','external') after id;
update ezin_authors set type = 'internal' where type is NULL or type = '';

-- from old update
update ezin_sections set lang = '' where lang is null;

-- for really long articles
alter table ezin_articles change bodytext bodytext longtext;

-- autor name resize
alter table ezin_authors modify name varchar(255);

-- credentials
alter table ezin_articles add column created_id int(10);
alter table ezin_articles add column created_by varchar(60);
alter table ezin_articles add column created_dt datetime;
alter table ezin_articles add column changed_id int(10);
alter table ezin_articles add column changed_by varchar(60);
alter table ezin_articles add column changed_dt datetime;

alter table ezin_authors add column created_id int(10);
alter table ezin_authors add column created_by varchar(60);
alter table ezin_authors add column created_dt datetime;
alter table ezin_authors add column changed_id int(10);
alter table ezin_authors add column changed_by varchar(60);
alter table ezin_authors add column changed_dt datetime;

alter table ezin_sections add column created_id int(10);
alter table ezin_sections add column created_by varchar(60);
alter table ezin_sections add column created_dt datetime;
alter table ezin_sections add column changed_id int(10);
alter table ezin_sections add column changed_by varchar(60);
alter table ezin_sections add column changed_dt datetime;

alter table ezin_editorials add column created_id int(10);
alter table ezin_editorials add column created_by varchar(60);
alter table ezin_editorials add column created_dt datetime;
alter table ezin_editorials add column changed_id int(10);
alter table ezin_editorials add column changed_by varchar(60);
alter table ezin_editorials add column changed_dt datetime;

alter table ezin_users add column created_id int(10);
alter table ezin_users add column created_by varchar(60);
alter table ezin_users add column created_dt datetime;
alter table ezin_users add column changed_id int(10);
alter table ezin_users add column changed_by varchar(60);
alter table ezin_users add column changed_dt datetime;

alter table ezin_roles add column created_id int(10);
alter table ezin_roles add column created_by varchar(60);
alter table ezin_roles add column created_dt datetime;
alter table ezin_roles add column changed_id int(10);
alter table ezin_roles add column changed_by varchar(60);
alter table ezin_roles add column changed_dt datetime;

alter table ezin_polls add column created_id int(10);
alter table ezin_polls add column created_by varchar(60);
alter table ezin_polls add column created_dt datetime;
alter table ezin_polls add column changed_id int(10);
alter table ezin_polls add column changed_by varchar(60);
alter table ezin_polls add column changed_dt datetime;

